%%Given an image and a set of features and their relative weights, compute
%%the most likely salinecy map

%% load inputs
num_features = 4;
features = [1 2 6 8];

%im = load('test_image.jpg');
%[dimx dimy] = size(im);

%% compute features for image
scale=10;
dimx = 480/scale; dimy = 640/scale;
f = zeros(num_features,dimx,dimy);
im_id=49;
 for k=1:num_features
        fname = ['data/features/f_' num2str(features(k)) '_' num2str(im_id) '.png'];
        f(k,:,:) = (1/255)*double(imresize(imread(fname),1/scale));
        f(k,:,:) = f(k,:,:)+0.465;
        f(k,:,:)=f(k,:,:)./max(max(f(k,:,:)));
 end
 

%% Set node and edge potentials
%create edgeStruct by first creating adjacency matrix
adj = create_adj(dimx,dimy);
edges = UGM_makeEdgeStruct(adj,2);
node_pot = zeros(dimx*dimy,2);
edge_pot = zeros(2,2,edges.nEdges);
lambda = 5*[0.36,0.24,0.22,0.18];

%set node potentials
for i=1:dimx
    for j=1:dimy
        idx = j+(i-1)*dimy;
        for k=1:num_features
            node_pot(idx,1) = node_pot(idx,1)+lambda(k)*(1-f(k,i,j));  
            node_pot(idx,2) = node_pot(idx,2)+lambda(k)*f(k,i,j);  
        end
    end
end 
 
%set edge potentials
for k=1:edges.nEdges
    %edge = edges.edgeEnds(k);
    edge_pot(1,1,k) = 1;
    edge_pot(1,2,k) = 0.1;
    edge_pot(2,1,k) = 0.1;
    edge_pot(2,2,k) = 1;
end
       
%% compute most likely configuration, reform to grid
node_ml = UGM_Decode_LBP(node_pot,edge_pot,edges);

A = zeros(dimx, dimy);

for n=1:dimx*dimy
    if mod(n,dimy)==0
        i=(n/dimy);
    else
        i = 1+floor(n/dimy);
    end
    j = n-(i-1)*dimy;
    A(i,j) = node_ml(n);
end

