function [bbox] = getBB(raw, thresh)
%note raw is a binary image
imshow(raw,[]);
raw = logical(raw);
[m n] = size(raw);
cent_x = 0; cent_y = 0;

for i=1:m
    for j=1:n
        if raw(i,j)
            cent_x = cent_x+i;
            cent_y = cent_y+j;
        end
    end
end
max_sum = sum(sum(raw(:,:)));
cent_x = floor(cent_x/max_sum);
cent_y = floor(cent_y/max_sum);

%%u,d,l,r indicated current bbox relative to centroid
up=0; down=0; left=0; right=0;
done=false;
while ~done
    %find additional pixels that can be gained by adding a row or column
    %convention 1=up, 2=down, 3=left, 4=right
    sum_dir = [-1 -1 -1 -1];
    if cent_x-up > 1
       sum_dir(1) = sum(raw(cent_x-up-1,cent_y-left:cent_y+right));    
    end
    if cent_x+down < m
       sum_dir(2) = sum(raw(cent_x+down+1,cent_y-left:cent_y+right));
    end
    if cent_y-left > 1
        sum_dir(3) = sum(raw(cent_x-up:cent_x+down,cent_y-left-1));    
    end
    if cent_y+right < n
       sum_dir(4) = sum(raw(cent_x-up:cent_x+down,cent_y+right+1));
    end
    
    %find the direction of largest gain
    [sum_dir seq] = sort(sum_dir);
    
    %increment the bbox in the direction of largest gain
    if seq(4)==1
        up = up+1;
    end
    if seq(4)==2
        down=down+1;
    end
    if seq(4)==3
        left = left+1;
    end
    if seq(4)==4
        right=right+1;
    end

    %check if 95% of pixels are covered
    if sum(sum(raw(cent_x-up:cent_x+down, cent_y-left:cent_y+right)))>thresh*max_sum
        done=true;
    end
end
    %compose u,d,l,r into a mask
    
    bbox = zeros(m,n);
    bbox(cent_x-up:cent_x+down, cent_y-left:cent_y+right) = 1;
    figure, imshow(bbox,[]);
end