%%Given a set of training data {image, groundtruth} and a set of features
%%compute optimal values of feature weights

%% load inputs
%{f_k_n,g_n} must all have equal sizes

num_images = 20;
scale = 16;
dimx = 480/scale; dimy = 640/scale;
%im = zeros(num_images, dimx, dimy);
G = zeros(num_images, dimx, dimy);
features = [1 2 6 8];
num_features = 4;
f = zeros(num_features,num_images,dimx,dimy);
step_size = 3*10^-3;

for n=1:num_images
    Gname = ['data/crops/g' num2str(n) '.png'];
    G(n,:,:) = (1/255)*double(imresize(imread(Gname),1/scale));
    for k=1:num_features
        fname = ['data/features/f_' num2str(features(k)) '_' num2str(n) '.png'];
        f(k,n,:,:) = (1/255)*double(imresize(imread(fname),1/scale));
        f(k,n,:,:) = f(k,n,:,:)+0.4;
        f(k,n,:,:)=f(k,n,:,:)./max(max(f(k,n,:,:)));
    end
    
    %f(num_features,n,:,:) = G(n,:,:);
end

%% initialize variables
conv = false;
lambda = zeros(20,num_features);
lambda(1,:) = [5 3 2 2];
del_lambda = zeros(20,num_features,1);
p_A_I = zeros(num_images,dimx*dimy,2);

%create edgeStruct by first creating adjacency matrix
adj = create_adj(dimx,dimy);
edges = UGM_makeEdgeStruct(adj,2);
clear adj;

iter=1;
%% main algorithm
while ~conv
    %first compute p_A_I for each image using UGM_Infer_TRBP here
    %note pixel grid must be converted to one-dimensional array
    iter = iter+1
    for n=1:num_images
            %set node pot
        node_pot = zeros(dimx*dimy,2);
        edge_pot = zeros(2,2,edges.nEdges);
        for i=1:dimx
           for j=1:dimy
               idx = j+(i-1)*dimy;
               for k=1:num_features 
                   node_pot(idx,1) = node_pot(idx,1)+lambda(iter-1,k)*(1-f(k,n,i,j));  
                   node_pot(idx,2) = node_pot(idx,2)+lambda(iter-1,k)*f(k,n,i,j);  
               end
               %sumpot = sum(node_pot(idx,:));
               %node_pot(idx,:) = node_pot(idx,:)/sumpot;
           end
       end       
       %set edge pots
       for k=1:edges.nEdges
           %edge = edges.edgeEnds(k);
           edge_pot(1,1,k) = 1;
           edge_pot(1,2,k) = 0.1;
           edge_pot(2,1,k) = 0.1;
           edge_pot(2,2,k) = 1;
       end
       %Use Loopy belief propagation to compute node marginals
       p_A_I(n,:,:) = UGM_Infer_LBP(node_pot,edge_pot,edges);
       n
    end
    
    %gradient descent
    for n=1:num_images
        for k=1:num_features
           for i=1:dimx
               for j=1:dimy             
               p = p_A_I(n,(i-1)*dimy+j,:);
               %case a(k,i,j)=0
               del_lambda(iter,k) = del_lambda(iter,k) + (1-f(k,n,i,j))*(p(1)-1+G(n,i,j)); 
               %case a(k,i,j)=1
               del_lambda(iter,k) = del_lambda(iter,k) + f(k,n,i,j)*(p(2)-G(n,i,j));
               end               
           end
       end
    end
   
   %del_lambda(iter,:) = del_lambda(iter,:)-(sum(del_lambda(iter,:))/num_features);
   lambda(iter,:) = lambda(iter-1,:) - step_size*del_lambda(iter,:);
   %lambda(iter,:) = lambda(iter,:)/sum(lambda(iter,:));
   
   %check for convergence
   if iter>20 || sum(del_lambda(iter,:).^2) < 1;
       conv = 1;
   end
   
end

    