%% load inputs
%{f_k_n,g_n} must all have equal sizes

num_images = 20;
scale = 20;
dimx = 480/scale; dimy = 640/scale;
%im = zeros(num_images, dimx, dimy);
G = zeros(num_images, dimx, dimy);
features = [1 2 6 8];
num_features = 4;
f = zeros(num_features,num_images,dimx,dimy);

for n=1:num_images
    Gname = ['data/crops/g' num2str(n) '.png'];
    G(n,:,:) = (1/255)*double(imresize(imread(Gname),1/scale));
    for k=1:num_features
        fname = ['data/features/f_' num2str(features(k)) '_' num2str(n) '.png'];
        f(k,n,:,:) = (1/255)*double(imresize(imread(fname),1/scale));
        f(k,n,:,:) = f(k,n,:,:)+0.4;
        f(k,n,:,:)=f(k,n,:,:)./max(max(f(k,n,:,:)));
    end
    
    %f(num_features,n,:,:) = G(n,:,:);
end

y  = zeros(num_images, dimx*dimy);
for n=1:num_images
    for i=1:dimx
        for j=1:dimy
            idx = j+(i-1)*dimy;
            if G(n,i,j)<0.5
                y(n,idx) = 1;
            else
                y(n,idx) = 2;
            end
        end
    end
end
Xnode = zeros(num_images, num_features, dimx*dimy);

for n=1:num_images
    for k=1:num_features
        for i=1:dimx
            for j=1:dimy
                idx = j+(i-1)*dimy;
                Xnode(n,k,idx) = f(k,n,i,j);
            end
        end
    end
end
clear f G
%create edgeStruct by first creating adjacency matrix
adj = create_adj(dimx,dimy);
edges = UGM_makeEdgeStruct(adj,2);
clear adj;

Xedge = ones(num_images,1,edges.nEdges);

nodeMap = zeros(dimx*dimy, 2, num_features, 'int32');
for k=1:num_features
    nodeMap(:,1,k) = k;
end
edgeMap = zeros(2,2,edges.nEdges,'int32');
edgeMap(1,1,:) = num_features+1;
edgeMap(2,1,:) = num_features+2;
edgeMap(1,2,:) = num_features+3;

nParams = max([nodeMap(:);edgeMap(:)]);
w = zeros(nParams,1);
w0 = 0.25*ones(size(w));
w = minFunc(@UGM_CRF_NLL,w0,[],Xnode,Xedge,y,nodeMap,edgeMap,edges,@UGM_Infer_LBP)











