%%mutli-scale contrast

for k=63:65
    k
    file = ['data/original/' num2str(k) '.png'];
    im = uint8(imread(file));
    [m n p] = size(im);
    res = zeros(m,n);
    max_pyr=5;
    pyr = zeros(max_pyr,m,n,3);
    %compute image pyramid
    for i=1:max_pyr
        temp = imresize(imresize(im,2^(-i)),2^i);
        pyr(i,:,:,:)=temp(:,:,:);
    end
    %compute multiscale contrast
    for i=2:m-1
        for j=2:n-1
            for p=1:max_pyr
                for c=1:3
                    res(i,j) = res(i,j) + (pyr(p,i,j,c)-pyr(p,i-1,j,c))*(pyr(p,i,j,c)-pyr(p,i-1,j,c));
                    res(i,j) = res(i,j) + (pyr(p,i,j,c)-pyr(p,i+1,j,c))*(pyr(p,i,j,c)-pyr(p,i+1,j,c));
                    res(i,j) = res(i,j) + (pyr(p,i,j,c)-pyr(p,i,j-1,c))*(pyr(p,i,j,c)-pyr(p,i,j-1,c));
                    res(i,j) = res(i,j) + (pyr(p,i,j,c)-pyr(p,i,j+1,c))*(pyr(p,i,j,c)-pyr(p,i,j+1,c));
                end
            end
        end
    end
    res = sqrt(res);
    %Threshold image here: Do we really need this?
    %thresh = mean(mean(res));
    %res_thresh = zeros(m,n);
    %for i=1:m
    %    for j=1:n
    %        if res(i,j)>thresh
    %            res_thresh(i,j) = res(i,j);
    %        end
    %    end
    %end
    
    %dilate result
    radius = 10;
    se = strel('ball',radius,radius);
    res1 = imfilter(imdilate(res,se),fspecial('gaussian',[5 5],2),'same');
    
    imwrite(uint8(res),['data/features/f_5_' num2str(k) '.png']);
    imwrite(uint8(res1),['data/features/f_6_' num2str(k) '.png']);

end